; -*- mode: emacs-lisp; -*-
;;; ciao-config.el --- Configuration parameters for this installation

;; Copyright (C) 1986-2012 Free Software Foundation, Inc. and
;; M. Hermenegildo and others (herme@fi.upm.es, UPM-CLIP, Spain).

;; This file is not part of GNU Emacs.

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 3, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to the
;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

(defvar ciao-bin-dir "/home/joaquin.arias/Ciao/Ciao-1.18-474-g4762bb60a/build/bin"
  "Where the actual Ciao binaries are.")

(defvar ciao-config 
  `(;; Emacs type (for ciao mode)
    :ciao-emacs-type "posix"
    ;; Version	     
    :version "1.18.0"
    ;; Paths
    :root-dir "/home/joaquin.arias/Ciao/Ciao-1.18-474-g4762bb60a"
    :bin-dir "/home/joaquin.arias/Ciao/Ciao-1.18-474-g4762bb60a/build/bin"
    :builddoc-dir "/home/joaquin.arias/Ciao/Ciao-1.18-474-g4762bb60a/build/doc"
    :bundledir-ciao-emacs "/home/joaquin.arias/Ciao/Ciao-1.18-474-g4762bb60a/bndls/ciao_emacs"
    :bundledir-lpdoc "/home/joaquin.arias/Ciao/Ciao-1.18-474-g4762bb60a/core"
    ;; Manuals
    :manual-bases ("gendot" "ciaodbg" "ciao_builder" "ciao_internals" "ciao_java" "ciao_tcltk" "ciaomath" "ciaopp" "davinci")
    ;; Binaries
    :ciaosh-bin ,(concat ciao-bin-dir "/ciao")    
    :ciaopp-bin ,(concat ciao-bin-dir "/ciaopp")
    :lpdoc-bin ,(concat ciao-bin-dir "/lpdoc")
    :ciaofmt-bin ,(concat ciao-bin-dir "/ciaofmt")
    ))

(defun ciao-get-config (prop)
  "Obtain configuration property `prop'"
  (plist-get ciao-config prop))


;; Provide ourselves:

(provide 'ciao-config)

;;; ciao-config.el ends here

