:- bundle(ciaopp).
depends([
  core
  % ciao_java,
  % ciaodbg, % (dependency from profcost, etc.)
  % ciaomath, % (dependency from poly_spec/, resources/, extra/Experiments/PCPD)
  % ciao_gsl, % (dependency from infercost/algebraic/polynom_comp_gsl.pl)
  % ciao_ppl, % (dependency from ciaopp.hooks.pl and domain(polyhedra))
  % ciao_llvm, % (dependency from xcore/)
  % timingmodel, % (dependency from resources/predefres/sta_exectime/*)
  % gendot, % (dependency from poly_spec/)
  % davinci % (for interactive trace)
]).
% TODO: Avoid dependency to mathematica from plai/domain/resources/*.

alias_paths([
    library = 'lib', % modules reachable as library(...)
    ciaopp = 'src',
    %
    ciaopp_docsrc = 'doc',
    ciaopp_tests = 'tests', % TODO: rarely used
    ciaopp_bugs = 'bugs', % TODO: rarely used
    ciaopp_examples = 'examples', % TODO: rarely used
    ciaopp_extra = 'extra', % TODO: rarely used
    %
    spec = 'spec',
    poly_spec = 'poly_spec',
    auto_interface = 'auto_interface',
    %
    domain = 'domains',
    typeslib = 'typeslib',
    %
    infernf = 'infernf',
    infercost = 'infercost',
    % resource analysis
    resources = 'resources',
    predefres = 'resources/predefres',
    profcost = 'resources/predefres/res_exectime_hlm/profiler', % TODO: move elsewhere?
    % resource analysis (under lib/) % TODO: group all under predefres?
    predefres = 'lib/resdefs/predefres',
    predefprf = 'lib/resdefs/predefprf',
    %
    % path aliases that correspond to different components
    cafelito = 'cafelito',
    ciaopp_xcore = 'xcore',
    ilciao = 'ilciao'
]).

lib('lib').
lib('src').
lib('domains').
lib('poly_spec').
lib('spec').
lib('typeslib').
lib('auto_interface').
% %
% lib('infercost').
% lib('infernf').  %%
% lib('resources').
% %
% lib('cafelito').
% lib('ilciao').
% lib('xcore').
%
%lib('extra').
%lib('bugs').
%lib('examples').
%lib('tests').

cmd('cmds/ciaopp-dump-fmt').
cmd('cmds/ciaopp-dump-cmp').

manual('ciaopp', [main='doc/reference/SETTINGS.pl']).
% manual('ciaopp_internals', [main='doc/internals/SETTINGS.pl']).
readme('INSTALLATION', [main='doc/readmes/INSTALLATION_CIAOPP.lpdoc']).
readme('CHANGELOG', [main='doc/readmes/CHANGELOG_CIAOPP.pl']).

