% (included file)

:- doc(section, "ilCiao (Java Analysis based on Soot)").

:- use_module(library(lists), [member/2]).
:- use_module(library(pathnames), [path_concat/3]).
:- use_module(library(bundle/bundle_paths), [bundle_path/3]).
:- use_module(ciaobld(builder_aux), [invoke_ant/2, remove_dir_nofail/1]).
:- use_module(library(system_extra), [del_file_nofail/1]).
:- use_module(library(glob), [glob/3]).
:- use_module(library(messages), [warning_message/1]).

% TODO: This should be: with_ilciao, which requires ant
with_ant := ~get_bundle_flag(ciao_java:with_ant).

'$builder_hook'(ilciao:build_bin) :- !,
	( with_ant(yes) ->
	    invoke_ant(~bundle_path(ciaopp, ilciao), [clean]), % TODO: this 'clean' should not be here
	    invoke_ant(~bundle_path(ciaopp, ilciao), [compile])
	; % Cannot do anything on ilciao sub-bundle if we do not have Ant
	  % TODO: Turn into a configuration flag instead (enable/disable ilciao)
	  % TODO: then replace config flag by a separate bundle?
	  warning_message(
            "Ant has not been detected by the 'ciao_java' bundle.\n"||
            "'ciaopp.ilciao' needs 'ant' as a build dependency.")
	).
'$builder_hook'(ilciao:clean_bin) :-
	do_delete_example_pl_files(~bundle_path(ciaopp, 'ilciao/examples/Resources')),
	remove_dir_nofail(~bundle_path(ciaopp, 'ilciao/classes')).

do_delete_example_pl_files(Dir) :-
	( member(File, ~glob(Dir, 'examples.*.pl')),
	    del_file_nofail(~path_concat(Dir, File)),
	    fail
	; true
	).

