% (included file)

:- doc(section, "Optional interface for Mathematica library").
% (from CiaoPP to Mathematica)

% TODO: reuse this code for creating optional dependecies, use condcomp?

:- use_module(library(stream_utils), [string_to_file/2]).
:- use_module(ciaobld(messages_aux), [verbose_message/2]).
:- use_module(engine(internals), ['$bundle_id'/1]).

mathematica_interface_file := ~bundle_path(ciaopp, 'domains/selected_mathematica_interface_auto.pl').
% TODO: get flag only if bundle is activated (do it for all other optional bundles)
mathematica_enabled := ~get_bundle_flag(mathematica:enabled) :- '$bundle_id'(mathematica).

selected_mathematica_interface_auto(P) :-
	( mathematica_enabled(yes) ->
	    mathematica_interface(P)
	; dummy_mathematica_interface(P)
	).
dummy_mathematica_interface := "domain(mathematica_ciao_dummy)".
mathematica_interface := "library(mathematica)".

create_mathematica_interface_file :-
	make_mathematica_interface_file(~mathematica_interface_file).

make_mathematica_interface_file(F) :-
	verbose_message("Generating ~w file", [F]),
	selected_mathematica_interface_auto(P),
	string_to_file(~flatten([
		    "%% Do not edit - automatically generated!\n\n"||
		    ":- module(_, _, _).\n"||
		    ":- reexport("|| P, ")."]), F).

