% (included file)

:- doc(section, "Optional interface for PPL library").
% (from CiaoPP to PPL)

% TODO: reuse this code for creating optional dependecies, use condcomp?

:- use_module(library(stream_utils), [string_to_file/2]).
:- use_module(ciaobld(messages_aux), [verbose_message/2]).
:- use_module(engine(internals), ['$bundle_id'/1]).

ppl_interface_file := ~bundle_path(ciaopp, 'domains/selected_ppl_interface_auto.pl').
% TODO: get flag only if bundle is activated (do it for all other optional bundles)
ppl_enabled := ~get_bundle_flag(ciao_ppl:enabled) :- '$bundle_id'(ciao_ppl).

selected_ppl_interface_auto(P) :-
	( ppl_enabled(yes) ->
	    ppl_interface(P)
	; dummy_ppl_interface(P)
	).
dummy_ppl_interface := "domain(ppl_ciao_dummy)".
ppl_interface := "library(ppl)".

create_ppl_interface_file :-
	make_ppl_interface_file(~ppl_interface_file).

make_ppl_interface_file(F) :-
	verbose_message("Generating ~w file", [F]),
	selected_ppl_interface_auto(P),
	string_to_file(~flatten([
		    "%% Do not edit - automatically generated!\n\n"||
		    ":- module(_, _, _).\n"||
		    ":- reexport("|| P, ")."]), F).
