/* This file is part of the Online Negative Database (NDB), Copyright
   (C) 2008 ackleyshack,LLC and Copyright (C) 2004-2008 elena s ackley
   and the Regents of the University of New Mexico.
 
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/*
 * -------------------------------------------------------------------------
 * Filename      : test.h
 * Language      : C using the GNU gcc compiler 
 * 
 * Purpose       : NDB Runtime Unit Tests
 * 
 * Creator       : E.S. Ackley
 * Creation Date : Tue Dec 28 17:16:59 2004 
 * Updated       : Thu May  8 14:44:58 2008 
 *
 * Comments      : based on the Fernando Esponda NDB Algorithms
 *
 * -------------------------------------------------------------------------
 */
#ifndef UNMNDBTESTRUNTIME_H
#define UNMNDBTESTRUNTIME_H

void test_runtime(int lenarg, int minbitsarg);
void test_runtime_empty(int lenarg, int minbitsarg);
void test_runtime_empty_randomSATformula(int lenarg, int minbitsarg); /* v.20 */
void test_runtime_singleton(int lenarg, int minbitsarg); /* v.21 */
void test_runtime_singleton_ascii(int lenarg, int minbitsarg); /* v.21 */
void test_runtime_singleton_double(int lenarg, int minbitsarg); /* v.70 */
void test_runtime_ascii(void);
void test_runtime_ascii2(void);
void test_runtime_ascii3(void);
void test_runtime_query(void);
void test_runtime_query_partial(void);
void test_runtime_copyproject(void);
void test_runtime_query_partial_binary(void);
void test_runtime_query_partial_binary2(void);
void  test_runtime_select_theta_binary(void);
void test_runtime_select_theta_ascii(void);
void test_runtime_select_theta_ascii_2(void);
void test_runtime_join_binary(void);
void test_runtime_join_ascii(void);
void test_runtime_intersection_binary(void);
void test_runtime_crossproduct_binary(void);
void test_runtime_crossproduct_ascii(void);
void test_runtime_join_ends_binary(void);
void test_runtime_union_binary(void);
void test_runtime_difference_binary(void);
void test_runtime_intersection_boundary(void);
void test_runtime_union_boundary(void);
void test_runtime_difference_boundary(void);

void test_runtime_complete8bit(void);
void test_runtime_random_qtrfull_8bit(int sarg);
void test_runtime_patterns(void);
void test_runtime_patterns2(void);
void test_runtime_pattern_sets(void);
void test_runtime_onebit_morph(void);
void test_runtime_emptyp(void);
void test_runtime_emptyp_100bit(int minbitarg);
void test_runtime_emptyp_100bit_singleton_with_2solutions(void);
void test_runtime_emptyp_100bit_singleton_infamous(void);

void test_runtime_imprecise_binary_union_of_patterns(void);
void test_runtime_imprecise_binary_union_of_patterns2(void);
void test_runtime_imprecise_binary_union_of_patterns3(void);
void test_runtime_imprecise_binary_union_of_patterns4(void);
void test_runtime_imprecise_binary_union_of_patterns5(void);

void test_runtime_binary_union_of_bits(void);
void test_runtime_binary_union_of_bits2(void);
void test_runtime_binary_union_of_bits3(void);
void test_runtime_binary_union_of_bits4(void);
void test_runtime_binary_union_of_bits5(void);
void test_runtime_binary_union_3673(void);
void test_runtime_binary_union_star_closure(void);

void test_complement(void);
void test_runtime_compare(int modearg);
void test_runtime_compare_directly(int modearg);
void test_runtime_compare_directly_mode2(int modearg);
void test_runtime_compare_binary(int modearg);
void test_runtime_compare_binary_directly_same(int modearg);
void test_runtime_compare_binary_directly_same_mode2(int modearg);
void test_runtime_compare_binary_directly_same_mode1(int modearg);
void test_runtime_compare_compressed_db_and_complement_ndb(int modearg);
void test_runtime_compare_binary_directly_different(int modearg);
void test_runtime_compare_binary_different(int modearg);
void test_runtime_relevance(void);
void test_runtime_relevance2(void);
void test_runtime_relevance3(void);
void test_runtime_relevance4(void);
void test_runtime_setdifference_binary(void);

#endif
