:- module(eq_solver_mathematica_config,
	[mathematica_kernel_link/1, mathematica_server_interface_path/1,mathematica_port_number/1,mathematica_jlink/1,mathematica_path/1],
	[ assertions, nativeprops, regtypes ]).

:- doc(mathematica_path/1,
	"The path where the Mathematica kernel is found.
        Change it depending on your operating system.").
mathematica_path("/Applications/Mathematica.app/Contents/MacOS/MathKernel -mathlink").

:- doc(mathematica_jlink/1,
	"Path where the Mathematica Java link is found.").
mathematica_jlink("/Applications/Mathematica.app/SystemFiles/Links/JLink/JLink.jar").

mathematica_kernel_link("-linkmode launch -linkname '\"/Applications/Mathematica.app/Contents/MacOS/MathKernel\" -mathlink'").

:- doc(mathematica_server_interface_path/1,
	"The path where @tt{mathinterface} is found. @tt{mathinterface} is
      the server that receives mathematica expressions as strings and sends them 
      to a MathKernel instance, through mathlink library.").
mathematica_server_interface_path(bundle_src(ciaopp)/domains/resources/eq_solver/mathinterface).

:- doc(mathematica_port_number/1,
	"The port where @tt{mathinterface} is listening.").
mathematica_port_number('8000').
