:- module(sized_types_aux_ai_info,_,[assertions]).
:- use_module(ciaopp(plai/domains)).
:- use_module(ciaopp(p_unit/clause_db), [source_clause/3]).
:- use_module(ciaopp(infer),[get_absint/4]).
:- use_module(ciaopp(plai/transform), [body_info0/4, trans_clause/3]).
:- use_module(library(terms_vars), [varset/2]).
:- use_module(library(sets), [merge/3, ord_subtract/3]).
:- use_module(library(sort), [sort/2]).



:- doc(module,
	"Small utilities used in size analysis for getting information inferred previously by PLAI, assuming the program to be analyzed is monovariant.").


can_fail(Sg,false):-
	get_complete_from_db(nf,Sg,_,nf(_,_,nf(_,_,not_fails))),!.
can_fail(_Sg,true).

get_tests_from_det(K,HvFv,T):-
	get_absint(K,det,HvFv,ASub),
	ASub = det(_,_,det([t(_,_,T,_)|_],_,_)).
get_tests_from_det(no_provided,_,[]):-!.
get_tests_from_det(_K,_HvFv,[]).

is_a_fact(K):-
	source_clause(K,clause(_H,B),_Dict),
	B = true:_.

:- export(get_complete_from_db/4).
get_complete_from_db(AbsInt,Sg,Proj,Succ):-
	get_absint(pred,AbsInt,Sg,(Proj,Succ)).
	
% get_entry_types(+,+,?,?,?,-,-).
get_entry_types(KClause,Sg,Head,Hv,Fv,Entry,Call,Prime):-
	get_complete_from_db(etermsvar,Sg,Proj,Prime),
	trans_clause(_,_,clause(Head,UVars,KClause,_Body)),
	varset(Head,Hv),
	varset(Sg,Sv),
	sort(UVars,Vars),
	ord_subtract(Vars,Hv,Fv),
	call_to_entry(etermsvar,Sv,Sg,Hv,Head,Fv,Proj,Entry,(no,Call)).

get_exit_types(KClause,Head,Hv,Fv,Exit):-
	trans_clause(_,_,clause(Head,UVars,KClause,_Body)),
	varset(Head,Hv),
	%varset(Sg,Sv),
	sort(UVars,Vars),
	ord_subtract(Vars,Hv,Fv),
	get_absint(KClause,etermsvar,Vars,Exit),!.
get_exit_types(KClause,Head,Hv,Fv,Exit):-
	functor(Head,F,N),functor(Sg,F,N),
	get_entry_types(KClause,Sg,Head,Hv,Fv,Exit,_Call,_Prime).