% (included file)
% Preprocess flags for xC frontend
%

pp_flag(inter_xcll).
pp_flag(inter_xcll, 'No Help Available').
current_pp_flags(  inter_xcll          , analyze ).
valid_flag_values( inter_xcll          , member( _ , [ analyze, check_assertions ] )).

pp_flag(inter_xcna).
pp_flag(inter_xcna, 'No Help Available').
current_pp_flags(  inter_xcna          , [types,modes,xc_ana_cost]   ).
valid_flag_values( inter_xcna          , sublist2( _ , [
						       types, %xc_types,
						       modes, %xc_modes,
						       xc_ana_cost
						     ] ) ).

pp_flag(menu_xc_level).
pp_flag(menu_xc_level, 'Select level of expertise').
current_pp_flags(  menu_xc_level    , naive ).
valid_flag_values( menu_xc_level    , member( _  , [naive, expert] ) ).

pp_flag(xc_modes).
pp_flag(xc_modes, 'Selects a domain for mode analysis').
current_pp_flags(  xc_modes              , none    ).
valid_flag_values( xc_modes              , modeanalysis( _ ) ).

pp_flag(xc_types).
pp_flag(xc_types, 'Selects a domain for type analysis').
current_pp_flags(  xc_types              , none  ).
valid_flag_values( xc_types              , typeanalysis( _ ) ).

pp_flag(xc_ana_cost).
pp_flag(xc_ana_cost, 'Type of cost (and size) analysis').
current_pp_flags(  xc_ana_cost           , res_plai    ).
valid_flag_values( xc_ana_cost           , member( _ , [none, res_plai, resources] )).

pp_flag(xc_energy_cost).
pp_flag(xc_energy_cost, 'Whether to include energy model in transformation').
current_pp_flags(  xc_energy_cost        , yes     ).
valid_flag_values( xc_energy_cost        , member( _ , [yes, no] )).

pp_flag(xcore_level).
pp_flag(xcore_level, 'Decides which optimization level will be used when calling the XC compiler.').
current_pp_flags(xcore_level,o0).
valid_flag_values(xcore_level,member(_,[o0,o1,o2])).

pp_flag(xc_layer).
pp_flag(xc_layer, 'The analysis layer for XC programs (LLVM IR or ISA).').
current_pp_flags(  xc_layer           , isa    ).
valid_flag_values( xc_layer           , member( _ , [isa, llvm] )).

