/*
 *  tabling.h
 *
 *  Support for tabling.
 *
 *  Copyright (C) 1996,1997,1998, 1999, 2000, 2001, 2002 UPM-CLIP
 */

#ifndef _CIAO_TABLING_H
#define _CIAO_TABLING_H

#if defined(TABLING)

/* #define GLOBAL_TABLE_SIZE        (300000*kCells) */
/* #define TABLING_STK_SIZE         (30000*kCells) */


extern tagged_t tabling_adjust;
extern tagged_t tabling_overflow;
extern tagged_t tabling_increase;
#if defined(DEBUG)
extern tagged_t tabling_debug;
extern tagged_t tabling_debug_tries;
extern tagged_t tabling_trace;
extern tagged_t tabling_print;
extern tagged_t tabling_bypass;
#endif

CVOID__PROTO(heap_overflow_adjust_tabling, intmach_t heap_factor);
CVOID__PROTO(stack_overflow_adjust_tabling, intmach_t stack_factor);
CVOID__PROTO(choice_overflow_adjust_tabling, intmach_t stack_factor);
CVOID__PROTO(reinit_tabling);

void init_global_table(int size);
void dealloc_global_table(void);
void init_tabling_stack(int size);
void dealloc_tabling_stk(tagged_t* ptr);

typedef struct stack_block_ {
  struct stack_block_ *bck;
  int size;
  tagged_t mem_ptr;
} stack_block_t;

extern stack_block_t *current_global_table;
extern stack_block_t *current_tabling_stack;


#define CONSUMER    0         
#define GENERATOR   1

extern tagged_t functor_forward_trail;

extern double trail_time;

extern tagged_t *global_table;
extern tagged_t *tabling_stack;

extern tagged_t *global_table_free;
extern tagged_t *tabling_stack_free;
extern tagged_t *global_table_end;
extern tagged_t *tabling_stack_end;

extern tagged_t global_table_size;
extern tagged_t tabling_stack_size; 
//extern stack_block_t *zombi_tabling_stack;

#define TABLING_STK_TOP tabling_stack_free

#define INIT_GLOBAL_TABLE(GLOBAL_TABLE_SIZE)				\
  {									\
    init_global_table(GLOBAL_TABLE_SIZE);				\
  }

#define INIT_TABLING_STACK(TABLING_STK_SIZE)	\
  {						\
    init_tabling_stack(TABLING_STK_SIZE);	\
  }

#define ALLOC_GLOBAL_TABLE(PTR,PTR_TYPE,SIZE)			\
  {								\
    (PTR) = (PTR_TYPE)global_table_free;			\
    global_table_free += (SIZE) / sizeof(tagged_t*);		\
								\
    if (global_table_free >= global_table_end) {		\
      if (tabling_increase == atom_on) {			\
	global_table_size = global_table_size * 2;		\
	if (global_table_size < 1.5*SIZE)			\
	  global_table_size = 2*SIZE;				\
	INIT_GLOBAL_TABLE(global_table_size);			\
      } else global_table = 0;					\
      if (global_table == 0) {					\
	fprintf(stderr, "Global table memory exhausted\n");	\
	SERIOUS_FAULT(" Trying ALLOC_GLOBAL_TABLE");		\
      }								\
      (PTR) = (PTR_TYPE)global_table_free;			\
      global_table_free += (SIZE) / sizeof(tagged_t*);		\
    }								\
  }

#define ALLOC_TABLING_STK(PTR,PTR_TYPE,SIZE)		\
  {							\
    (PTR) = (PTR_TYPE)tabling_stack_free;		\
    tabling_stack_free += (SIZE) / sizeof(tagged_t*);	\
    							\
    if (tabling_stack_free >= tabling_stack_end) {	\
      if (tabling_increase == atom_on) {		\
	tabling_stack_size = tabling_stack_size * 2;	\
	if (tabling_stack_size < 1.5*SIZE)		\
	  tabling_stack_size = 2*SIZE;			\
	INIT_TABLING_STACK(tabling_stack_size);		\
      } else tabling_stack = 0;				\
      if (tabling_stack == 0) {				\
	fprintf(stderr, "Tabling stack exhausted\n");	\
	SERIOUS_FAULT(" Trying ALLOC_TABLING_STK");	\
      }							\
      (PTR) = (PTR_TYPE)tabling_stack_free;		\
      tabling_stack_free += (SIZE) / sizeof(tagged_t*);	\
    }							\
  }

#define DEALLOC_GLOBAL_TABLE			\
  {						\
    dealloc_global_table();			\
  }

#define DEALLOC_TABLING_STK(PTR)		\
  {						\
    dealloc_tabling_stk((tagged_t *) PTR);	\
  }

#define INIT_NODE_TR(NodeTR)						\
  {									\
    ALLOC_TABLING_STK((NodeTR),node_tr_t*,sizeof(node_tr_t));		\
    NODE_TR_SIZE(NodeTR) = 0;						\
    NODE_TR_TRAIL_SG(NodeTR) = NULL;					\
    NODE_TR_NEXT(NodeTR) = NULL;					\
    NODE_TR_CHAIN(NodeTR) = NULL;					\
  }

#define INIT_REG_NODE_TR(NodeTR)					\
  {									\
    ALLOC_TABLING_STK((NodeTR), tagged_t, sizeof(node_tr_t));		\
    NODE_TR_NEXT(NodeTR) = NULL;					\
    NODE_TR_CHAIN(NodeTR) = NULL;					\
    NODE_TR_SIZE(NodeTR) = (w->trail_top - TagToPointer(B->trail_top)) * 2; \
    ALLOC_TABLING_STK							\
      (NODE_TR_TRAIL_SG(NodeTR), tagged_t*,				\
       NODE_TR_SIZE(NodeTR) * sizeof(tagged_t));			\
  }

#define MAKE_TRAIL_CACTUS_STACK						\
  {									\
    if (FrozenChpt(B) && (FirstNodeTR(B) != NULL))			\
      {									\
	/* Create current node_trail */					\
    INIT_REG_NODE_TR(t0);						\
	/* printf("\nMAKING CACTUS STACK %p trail_top = %d\n",		*/ \
	/*        (void*)t0, (int)TrailDifference(Trail_Start, w->trail_top));  */ \
									\
	if (NODE_TR_SIZE(t0))						\
	  {								\
	    /*    printf("\nNODE_TR_SIZE = %d | w->trail_top = %d | B->trail_top = %d \n\n", NODE_TR_SIZE(t0), (int)TrailDifference(Trail_Start, w->trail_top), (int)TrailDifference(Trail_Start, TagToPointer(B->trail_top))); */ \
	    tagged_t *pt3 = NODE_TR_TRAIL_SG(t0);			\
	    for (pt2 = w->trail_top-1,					\
		   t2=(tagged_t)TagToPointer(B->trail_top);		\
		 !TrailYounger(t2,pt2); pt2--)				\
	      {								\
		t3 = *pt2;						\
		/* printf("\nCurrent value %d \t",			*/ \
		/*        (int)TrailDifference(Trail_Start, pt2));	*/ \
		/* PRINT_TERM_DEREF_ENGINE(w, "  \t", *pt2);		*/ \
		if (IsVar(t3))						\
		  {							\
		    *pt3 = t3; pt3++;					\
		    *pt3 = *TagToPointer(t3); pt3++;			\
		  }							\
		else							\
		  {							\
		    if (*TagToPointer(t3) == functor_forward_trail)	\
		      { 						\
			*pt3 = t3; pt3++;				\
			*pt3 = t3; pt3++;				\
		      } 						\
		    else						\
		      {							\
			NODE_TR_SIZE(t0) = NODE_TR_SIZE(t0) - 2;	\
		      }							\
		  }							\
	      }								\
	    								\
	    /*children trail segments point to the new node_trail*/	\
	    for (t1 = (tagged_t)NODE_TR_CHAIN(FirstNodeTR(B));		\
		 t1 != (tagged_t)NULL;					\
		 t1 = (tagged_t)NODE_TR_CHAIN(t1))			\
	      {								\
		NODE_TR_NEXT(t1) = (node_tr_t *)t0;			\
		/*printf("\n%p parent of %p\n",t0,t1);*/		\
	      }								\
									\
	    /*Link from first_node_tr*/					\
	    NODE_TR_CHAIN(FirstNodeTR(B)) = (node_tr_t *)t0;		\
	    /*printf("\nChain of %p = %p\n",FirstNodeTR(B),t0);*/	\
									\
	    /*Update last_node_tr*/					\
	    LastNodeTR = (node_tr_t *)t0;				\
	    /*printf("\nLastNodeTR %p\n",LastNodeTR);*/			\
	  }								\
	/*Mark current choice_pt*/					\
	SetFirstNodeTR(B,NULL);						\
      }									\
  }



#endif

//TRAIL CACTUS STACK IMPLEMENTATION
//=================================
//
//A - On consumer suspension, all the choices are marked as frozen 
//    (using global_top - HeapFReg) and the Last_Node_tr is saved 
//    (using local_top).
//
//B - On backtracking, from initial node_tr (local_top) until
//    Last_Node_tr point to the save father.
//
//C - On consumer resumption, its node_tr is used as Last_Node_tr.

#endif /* _CIAO_TABLING_H */
