#ifndef _CIAO_APLL_H
#define _CIAO_APLL_H

#if defined(THREADS) && defined(USE_POSIX_THREADS)
extern pthread_attr_t joinable_thread;
#endif

/* state of execution */
#define NOTEXECUTED    0
#define REM_EXECUTING  1
#define REEXECUTE      2
#define CANCELLING     3
#define CANCELLED      4
#define FINISHED       5
#define NO_MORE_SOLS   6
#define MORE_SOLS      7

#define NUMBER_STATES  8

/* TODO (JFMC): improper use of header, define in .c file instead */
try_node_t *address_nd_environment_protection_c;

/* ****************************************** */
/*   ANDPROLOG LOW-LEVEL SUPPORT PRIMITIVES   */
/* ****************************************** */
CBOOL__PROTO(apll_start_thread);
CBOOL__PROTO(apll_number_agents);
CBOOL__PROTO(apll_push_goal);
CBOOL__PROTO(apll_find_goal);
CBOOL__PROTO(apll_goal_available);
CBOOL__PROTO(apll_cancellation);
CBOOL__PROTO(apll_free_memory);
CBOOL__PROTO(apll_retrieve_goal);
CBOOL__PROTO(apll_goal_det);
CBOOL__PROTO(apll_set_goal_det);
CBOOL__PROTO(apll_set_goal_nondet);
CBOOL__PROTO(apll_goal_not_executed);
CBOOL__PROTO(apll_set_goal_not_executed);
CBOOL__PROTO(apll_goal_rem_executing);
CBOOL__PROTO(apll_set_goal_rem_executing);
CBOOL__PROTO(apll_goal_finished);
CBOOL__PROTO(apll_set_goal_finished);
CBOOL__PROTO(apll_goal_tobacktrack);
CBOOL__PROTO(apll_set_goal_tobacktrack);
CBOOL__PROTO(apll_goal_toreexecute);
CBOOL__PROTO(apll_set_goal_toreexecute);
CBOOL__PROTO(apll_goal_failed);
CBOOL__PROTO(apll_set_goal_failed);
CBOOL__PROTO(apll_goal_cancelled);
CBOOL__PROTO(apll_set_goal_cancelled);

CBOOL__PROTO(apll_send_event);
CBOOL__PROTO(apll_read_event);
CBOOL__PROTO(apll_save_init_execution);
CBOOL__PROTO(apll_save_end_execution);
CBOOL__PROTO(apll_more_solutions);
CBOOL__PROTO(apll_move_execution_top);
CBOOL__PROTO(apll_move_pointers_down);
CBOOL__PROTO(apll_metacut_garbage_slots);

CBOOL__PROTO(apll_waiting);
CBOOL__PROTO(apll_suspend);
CBOOL__PROTO(apll_release);
CBOOL__PROTO(apll_release_remote);
CBOOL__PROTO(apll_release_some_suspended_thread);
CBOOL__PROTO(apll_release_all_for_unwinding);
CBOOL__PROTO(apll_enter_mutex);
CBOOL__PROTO(apll_enter_mutex_self);
CBOOL__PROTO(apll_enter_mutex_remote);
CBOOL__PROTO(apll_exit_mutex);
CBOOL__PROTO(apll_exit_mutex_self);
CBOOL__PROTO(apll_exit_mutex_remote);

CBOOL__PROTO(apll_clean_measures);
CBOOL__PROTO(apll_print_measures);
CBOOL__PROTO(apll_new_measure);
CBOOL__PROTO(apll_not_measure);
CBOOL__PROTO(apll_incr_num_local_backtr);

CBOOL__PROTO(init);

#endif /* _CIAO_APLL_H */
